# Darknet Diaries LLM
## What is Darknet Diaries?
Well, let's ask our LLM:

> &gt; What is Darknet Diaries?
> > Darknet Diaries is a podcast that explores true stories from the dark side of the internet. Hosted by Jack Rhysider, each episode delves into various topics related to hacking, cybercrime, and the underground world of the internet. The podcast features interviews with individuals who have been involved in hacking incidents, cyber espionage, or have experienced the consequences of online criminal activities. Darknet Diaries aims to educate and entertain listeners by providing an in-depth look into the fascinating and often mysterious world of the darknet.

## How to run
### Install dependencies
I have no idea what the correct way to install dependencies with python is. Somehow install these libraries and their dependencies:
- llama_index
- beautifulsoup4
### Execution
Download transcripts:
```shell
python3 download_transcripts.py
```

Set OpenAPI key as environment variable
```shell
OPEN_API_KEY=<your key>
```

Then run the main file
```shell
python3 main.py
```

On the first run, it will generate the index. This can take a while, but it will be cached on disk for the next runs.

You can then ask it any questions about Darknet Diaries! Currently, it does hallucinate a lot about episode numbers and titles. Other than that, it's pretty accurate!

## Examples

### Episode 137: Predator
[link to transcript](https://darknetdiaries.com/transcript/137/)

> What is the spyware predator ?
>> The Predator is a phone-hacking software developed by a company called Cytrox. It was discovered by Citizen Lab during their investigations. Once installed on a phone, the Predator spyware has the capability to exfiltrate files from the phone, take passwords, turn on the microphone and listen in to what's going on. It is typically installed on a victim's phone through a phishing text message that prompts the user to click a link. Once the link is clicked, it triggers a series of exploits on the phone, eventually installing the spyware. The malware then erases the tracks of the infection process.
> 
> What happened to the egyptian journalists?
>> I'm sorry, but I don't have specific information about what happened to the Egyptian journalists. Could you please provide more details or context?
>
> Related to predator
>> The Egyptian journalist, along with an Egyptian politician living in exile, were found to have Predator spyware on their phones. This led to suspicions that the Egyptian government might be using this technology to spy on their civil society.
>
> How is Bill Marczak related to this story
>> Bill Marczak is a senior researcher at the Citizen Lab at the University of Toronto. He was involved in the Predator spyware story as he and his team discovered and analyzed the Predator spyware. They found it while examining phones for another spyware called Pegasus. They were able to analyze the final payload of the spyware, understand what it was doing, and attribute it back to Predator. They also investigated the companies behind Predator, like Cytrox and Intellexa, and tried to understand the geopolitical implications of such an exploit being sold on the mercenary marketplace.
>
> When did they first discovered samples of predator ?
>> I'm sorry, but I don't have specific information about when the Predator spyware was first discovered. Could you please provide more details or context?
>
> something about Payload 2...
>> Payload 2 is a suspicious process that was discovered on a phone during an investigation by Citizen Lab. It didn't match any previously-known malware that they had been tracking on phones. Upon further analysis, it was found that the arguments passed into this process when it was started up included a URL, which led to a binary file for an iPhone. This binary file was an application that was identified as spyware with capabilities to exfiltrate files from the phone, take passwords, and turn on the microphone. Through further analysis, it was attributed back to Predator, a spyware made by Cytrox.
>
> In which episode is this topic discussed ?
>> The Predator spyware is discussed in the Darknet Diaries episode number 137.